c-------------------------------------------  
      function xex(t)
c Solution exacte du probleme de Cauchy x'(t)=f(t,x(t))
c où f est defini ci-dessous
      implicit none
      double precision xex,t
       xex = dexp(-2.0d0*t)
      end
c-------------------------------------------  
      function f(t,x)
      implicit none
      double precision f,t,x
      f= -2.0d0*x
      end
c-------------------------------------------  
      subroutine euler(N,a,b,t,x)
c Schema d'Euler explicite
      implicit none
      double precision a,b,t(*),x(*),dt,f
      external f
      integer N,i

      dt = (b-a)/dble(N)
      t(1) = a
      do i=1, N       
        t(i+1) = a+dble(i)*dt
        x(i+1) =x(i)+dt*f(t(i),x(i))
      enddo
      end 

